<template>
  <div>
    <q-select
      v-if="displaySiteSelection"
      :model-value="value"
      @update:model-value="updateValue"
      :options="options"
      :label="$gettext('Sites')"
      emit-value
      :display-value="selectedSiteName"
      :dense="dense"
    >
      <template
        v-if="value && authorizeNoValue"
        #append
      >
        <q-icon
          name="las la-times"
          @click.stop.prevent="updateValue('')"
          size="sm"
          class="cursor-pointer"
        />
      </template>
    </q-select>
    <!-- <template v-else>
      <span>
        <translate>Site</translate>: {{ selectedSiteName }}
      </span>
    </template> -->
  </div>
</template>

<script>
export default {
  name: 'SiteSelection',
  props: {
    value: {
      type: Number,
      required: true
    },
    sites: {
      type: Array,
      required: true
    },
    authorizeNoValue: {
      type: Boolean,
      default: true
    },
    dense: {
      type: Boolean,
      default: false
    }
  },
  emits: ['update-site'],
  computed: {
    options () {
      return this.sites.map(site => {
        // transform the site data to an option usable in the select
        return {
          label: site.name || site.id,
          value: site.id
        }
      })
    },
    displaySiteSelection () {
      if (this.authorizeNoValue) {
        return true
      } else {
        // display the sites selection component only if there is more than 1 site.
        return this.sites.length > 1
      }
    },
    selectedSiteName () {
      if (this.value) {
        // return the name, or id, of the selected site
        return this.options.find(option => option.value === this.value).label
      } else {
        return ''
      }
    }
  },
  methods: {
    updateValue (newValue) {
      this.$emit('update-site', newValue)
    }
  }
}
</script>
